/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.springblade.estate.entity.WorkOrderGroup;
import org.springblade.estate.entity.WorkOrderGroupUser;
import org.springblade.estate.service.IWorkOrderGroupUserService;
import org.springblade.estate.vo.WorkOrderGroupSimpleVO;
import org.springblade.estate.vo.WorkOrderGroupUserVO;
import org.springblade.estate.vo.WorkOrderGroupVO;
import org.springblade.estate.mapper.WorkOrderGroupMapper;
import org.springblade.estate.service.IWorkOrderGroupService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.estate.wrapper.WorkOrderGroupUserWrapper;
import org.springblade.estate.wrapper.WorkOrderGroupWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.ArrayList;
import java.util.List;

/**
 * 工单团队 服务实现类
 *
 * @author BladeX
 * @since 2022-01-19
 */
@Service
public class WorkOrderGroupServiceImpl extends BaseServiceImpl<WorkOrderGroupMapper, WorkOrderGroup> implements IWorkOrderGroupService {

	@Autowired
	private IWorkOrderGroupUserService workOrderGroupUserService;

	@Override
	public IPage<WorkOrderGroupVO> selectWorkOrderGroupPage(IPage<WorkOrderGroupVO> page, WorkOrderGroupVO workOrderGroup) {
		return page.setRecords(baseMapper.selectWorkOrderGroupPage(page, workOrderGroup));
	}

	@Override
	public List<WorkOrderGroupVO> tree(Integer groupType) {
		List<WorkOrderGroup> groupList = this.list(new LambdaQueryWrapper<WorkOrderGroup>().eq(groupType != null, WorkOrderGroup::getGroupType, groupType));
		List<WorkOrderGroupVO> groupVOList = new ArrayList<>();
		for(WorkOrderGroup workOrderGroup : groupList){
			WorkOrderGroupVO workOrderGroupVO = WorkOrderGroupWrapper.build().entityVO(workOrderGroup);
			workOrderGroupVO.setLabel(workOrderGroup.getName());
			workOrderGroupVO.setValue(workOrderGroup.getId());
			List<WorkOrderGroupUser> groupUserList = workOrderGroupUserService.getByGroupId(workOrderGroup.getId());
			List<WorkOrderGroupUserVO> groupUserVOList = new ArrayList<>();
			for(WorkOrderGroupUser workOrderGroupUser : groupUserList){
				WorkOrderGroupUserVO groupUserVO = WorkOrderGroupUserWrapper.build().entityVO(workOrderGroupUser);
				groupUserVO.setLabel(workOrderGroupUser.getPerson());
				groupUserVO.setValue(workOrderGroupUser.getId());
				groupUserVOList.add(groupUserVO);
			}
			workOrderGroupVO.setChildren(groupUserVOList);
			groupVOList.add(workOrderGroupVO);
		}
		return groupVOList;
	}

	@Override
	public List<WorkOrderGroupSimpleVO> select(Integer groupType) {
		LambdaQueryWrapper<WorkOrderGroup> lambdaQueryWrapper = new LambdaQueryWrapper<>();
		lambdaQueryWrapper.eq(groupType != null, WorkOrderGroup::getGroupType, groupType);
		lambdaQueryWrapper.orderByDesc(WorkOrderGroup::getCreateTime);
		List<WorkOrderGroup> groupList = baseMapper.selectList(lambdaQueryWrapper);
		return WorkOrderGroupWrapper.build().listSimpleVO(groupList);
	}

}
